package ru.myitschool.work.data;

import androidx.annotation.NonNull;
import androidx.camera.core.processing.SurfaceProcessorNode;

import java.util.ArrayList;
import java.util.List;
import java.util.function.Consumer;

import ru.myitschool.work.data.dto.HistoryDto;
import ru.myitschool.work.data.dto.UserDto;
import ru.myitschool.work.data.network.RetrofitFactory;
import ru.myitschool.work.data.source.CredentialsDataSource;
import ru.myitschool.work.data.source.UserApi;
import ru.myitschool.work.domain.entities.HistioryEntity;
import ru.myitschool.work.domain.entities.Status;
import ru.myitschool.work.domain.entities.UserEntity;

public class UserResponseImpl {

    private static  UserResponseImpl INSTANCE;
    private UserApi userApi = RetrofitFactory.getInstance().getUserApi();
    private final CredentialsDataSource credentialsDataSource = CredentialsDataSource.getInstance();

    private UserResponseImpl() {}

    public static synchronized UserResponseImpl getInstance() {
        if (INSTANCE == null) {
            INSTANCE = new UserResponseImpl();
        }
        return INSTANCE;
    }


    public void getAllUsers(@NonNull Consumer<Status<List<UserEntity>>> callback) {
        userApi.getAllUsers().enqueue(new CallToConsumer<>(
                callback,
                usersDto -> {
                    ArrayList<UserEntity> result = new ArrayList<>(usersDto.size());
                    for (UserDto user : usersDto) {
                        final String username = user.username;
                        final String photo = user.photo;
                        final Long lastVisit = user.lastVisit;
                        final Integer idUser = user.idUser;
                        final String position = user.position;
                        if (idUser != null && username != null) {
                            result.add(new UserEntity(username, photo, lastVisit, idUser, position));
                        }
                    }
                    return result;
                }
        ));

    }





}
